
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.enderitestuff.init;

import net.neoforged.neoforge.registries.DeferredRegister;
import net.neoforged.neoforge.registries.DeferredHolder;
import net.neoforged.neoforge.event.entity.RegisterSpawnPlacementsEvent;
import net.neoforged.neoforge.event.entity.EntityAttributeCreationEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.resources.ResourceKey;
import net.minecraft.core.registries.Registries;

import net.mcreator.enderitestuff.entity.SpikeEntity;
import net.mcreator.enderitestuff.entity.SpearEntity;
import net.mcreator.enderitestuff.entity.RayEntity;
import net.mcreator.enderitestuff.entity.MiningLazerEntity;
import net.mcreator.enderitestuff.entity.LazerEntity;
import net.mcreator.enderitestuff.entity.GhostEntity;
import net.mcreator.enderitestuff.entity.DungeonWhirlEntity;
import net.mcreator.enderitestuff.entity.DungeonMasterEntity;
import net.mcreator.enderitestuff.entity.CaveCrawlerEntity;
import net.mcreator.enderitestuff.entity.BeamEntity;
import net.mcreator.enderitestuff.EnderiteStuffMod;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public class EnderiteStuffModEntities {
	public static final DeferredRegister<EntityType<?>> REGISTRY = DeferredRegister.create(Registries.ENTITY_TYPE, EnderiteStuffMod.MODID);
	public static final DeferredHolder<EntityType<?>, EntityType<LazerEntity>> LAZER = register("lazer",
			EntityType.Builder.<LazerEntity>of(LazerEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<MiningLazerEntity>> MINING_LAZER = register("mining_lazer",
			EntityType.Builder.<MiningLazerEntity>of(MiningLazerEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<DungeonWhirlEntity>> DUNGEON_WHIRL = register("dungeon_whirl",
			EntityType.Builder.<DungeonWhirlEntity>of(DungeonWhirlEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<DungeonMasterEntity>> DUNGEON_MASTER = register("dungeon_master",
			EntityType.Builder.<DungeonMasterEntity>of(DungeonMasterEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 1.8f));
	public static final DeferredHolder<EntityType<?>, EntityType<SpearEntity>> SPEAR = register("spear",
			EntityType.Builder.<SpearEntity>of(SpearEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<RayEntity>> RAY = register("ray",
			EntityType.Builder.<RayEntity>of(RayEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<BeamEntity>> BEAM = register("beam",
			EntityType.Builder.<BeamEntity>of(BeamEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final DeferredHolder<EntityType<?>, EntityType<CaveCrawlerEntity>> CAVE_CRAWLER = register("cave_crawler",
			EntityType.Builder.<CaveCrawlerEntity>of(CaveCrawlerEntity::new, MobCategory.CREATURE).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.8f, 0.6f));
	public static final DeferredHolder<EntityType<?>, EntityType<SpikeEntity>> SPIKE = register("spike",
			EntityType.Builder.<SpikeEntity>of(SpikeEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(0).setUpdateInterval(3).fireImmune().sized(1f, 1f));
	public static final DeferredHolder<EntityType<?>, EntityType<GhostEntity>> GHOST = register("ghost",
			EntityType.Builder.<GhostEntity>of(GhostEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).fireImmune().sized(0.6f, 1.8f));

	// Start of user code block custom entities
	// End of user code block custom entities
	private static <T extends Entity> DeferredHolder<EntityType<?>, EntityType<T>> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		return REGISTRY.register(registryname, () -> (EntityType<T>) entityTypeBuilder.build(ResourceKey.create(Registries.ENTITY_TYPE, ResourceLocation.fromNamespaceAndPath(EnderiteStuffMod.MODID, registryname))));
	}

	@SubscribeEvent
	public static void init(RegisterSpawnPlacementsEvent event) {
		DungeonMasterEntity.init(event);
		CaveCrawlerEntity.init(event);
		SpikeEntity.init(event);
		GhostEntity.init(event);
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(DUNGEON_MASTER.get(), DungeonMasterEntity.createAttributes().build());
		event.put(CAVE_CRAWLER.get(), CaveCrawlerEntity.createAttributes().build());
		event.put(SPIKE.get(), SpikeEntity.createAttributes().build());
		event.put(GHOST.get(), GhostEntity.createAttributes().build());
	}
}
