
/*
 *	MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.enderitestuff.init;

import org.lwjgl.glfw.GLFW;

import net.neoforged.neoforge.network.PacketDistributor;
import net.neoforged.neoforge.client.event.RegisterKeyMappingsEvent;
import net.neoforged.neoforge.client.event.ClientTickEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.api.distmarker.Dist;

import net.minecraft.client.Minecraft;
import net.minecraft.client.KeyMapping;

import net.mcreator.enderitestuff.network.ShiftClickTesterMessage;
import net.mcreator.enderitestuff.network.JetpackModeSwitchMessage;
import net.mcreator.enderitestuff.network.JetpackKeyMessage;
import net.mcreator.enderitestuff.network.HoverValueMessage;
import net.mcreator.enderitestuff.network.EarthDeleterMessage;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD, value = {Dist.CLIENT})
public class EnderiteStuffModKeyMappings {
	public static final KeyMapping JETPACK_KEY = new KeyMapping("key.enderite__stuff.jetpack_key", GLFW.GLFW_KEY_SPACE, "key.categories.movement") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				PacketDistributor.sendToServer(new JetpackKeyMessage(0, 0));
				JetpackKeyMessage.pressAction(Minecraft.getInstance().player, 0, 0);
				JETPACK_KEY_LASTPRESS = System.currentTimeMillis();
			} else if (isDownOld != isDown && !isDown) {
				int dt = (int) (System.currentTimeMillis() - JETPACK_KEY_LASTPRESS);
				PacketDistributor.sendToServer(new JetpackKeyMessage(1, dt));
				JetpackKeyMessage.pressAction(Minecraft.getInstance().player, 1, dt);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping JETPACK_MODE_SWITCH = new KeyMapping("key.enderite__stuff.jetpack_mode_switch", GLFW.GLFW_KEY_Z, "key.categories.movement") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				PacketDistributor.sendToServer(new JetpackModeSwitchMessage(0, 0));
				JetpackModeSwitchMessage.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping SHIFT_CLICK_TESTER = new KeyMapping("key.enderite__stuff.shift_click_tester", GLFW.GLFW_KEY_LEFT_SHIFT, "key.categories.misc") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				PacketDistributor.sendToServer(new ShiftClickTesterMessage(0, 0));
				ShiftClickTesterMessage.pressAction(Minecraft.getInstance().player, 0, 0);
				SHIFT_CLICK_TESTER_LASTPRESS = System.currentTimeMillis();
			} else if (isDownOld != isDown && !isDown) {
				int dt = (int) (System.currentTimeMillis() - SHIFT_CLICK_TESTER_LASTPRESS);
				PacketDistributor.sendToServer(new ShiftClickTesterMessage(1, dt));
				ShiftClickTesterMessage.pressAction(Minecraft.getInstance().player, 1, dt);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping HOVER_VALUE = new KeyMapping("key.enderite__stuff.hover_value", GLFW.GLFW_KEY_B, "key.categories.devtools") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				PacketDistributor.sendToServer(new HoverValueMessage(0, 0));
				HoverValueMessage.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};
	public static final KeyMapping EARTH_DELETER = new KeyMapping("key.enderite__stuff.earth_deleter", GLFW.GLFW_KEY_DELETE, "key.categories.devtools") {
		private boolean isDownOld = false;

		@Override
		public void setDown(boolean isDown) {
			super.setDown(isDown);
			if (isDownOld != isDown && isDown) {
				PacketDistributor.sendToServer(new EarthDeleterMessage(0, 0));
				EarthDeleterMessage.pressAction(Minecraft.getInstance().player, 0, 0);
			}
			isDownOld = isDown;
		}
	};
	private static long JETPACK_KEY_LASTPRESS = 0;
	private static long SHIFT_CLICK_TESTER_LASTPRESS = 0;

	@SubscribeEvent
	public static void registerKeyMappings(RegisterKeyMappingsEvent event) {
		event.register(JETPACK_KEY);
		event.register(JETPACK_MODE_SWITCH);
		event.register(SHIFT_CLICK_TESTER);
		event.register(HOVER_VALUE);
		event.register(EARTH_DELETER);
	}

	@EventBusSubscriber({Dist.CLIENT})
	public static class KeyEventListener {
		@SubscribeEvent
		public static void onClientTick(ClientTickEvent.Post event) {
			if (Minecraft.getInstance().screen == null) {
				JETPACK_KEY.consumeClick();
				JETPACK_MODE_SWITCH.consumeClick();
				SHIFT_CLICK_TESTER.consumeClick();
				HOVER_VALUE.consumeClick();
				EARTH_DELETER.consumeClick();
			}
		}
	}
}
